#
# Copyright (C) 2025 Indiscale GmbH <info@indiscale.com>
# Copyright (C) 2025 Florian Spreckelsen <f.spreckelsen@indiscale.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <https://www.gnu.org/licenses/>.
#
import linkahead as db

from .utils import get_entity_name


def get_container_by_identifier(identifier: str) -> db.Record:
    """Return a container identified by the given string identifier."""
    # First try (integer) ID
    try:
        identifier = int(identifier)
        query = f"FIND '{get_entity_name('container_rt')}' WITH ID={identifier}"
    except ValueError:
        # Then fall back to name or label
        query = (f"FIND '{get_entity_name('container_rt')}' WITH "
                 f"name='{identifier}' OR WITH "
                 f"'{get_entity_name('container_label_prop')}'='{identifier}'")

    return db.cached.cached_query(query)
